// qban.cs
// Authors: [OF] Pincushion
// Last updated: Apr 30, 2001
//
// Documentation is in qban.txt.

$Qver = "0.1";
$Qn = 0;

// Do NOT specify a folder in $Qlistfile, SS may crash if you try.
$Qlistfile = "qbanlist.cs";

// The message a bootee sees is prefixed with:
// CONNECTION REJECTED. YOU HAVE BEEN BANNED FROM THIS SERVER FOR x MINUTES.
// Maybe include an email address where the poor guy can appeal your ban...
$Qreason = "\nIt's actually a PERMANENT ban.\nHave a nice day.";

// Client administration password goes between the "" below.
// Passwords are case-sensitive!
$Qpassword = "";

// Clients that get the password wrong this many times will be auto-banned.
$Qmaxbadpw = 4;

// How many minutes players are ban()ed for.
// Its a balance between being long enough so bad guys get bored trying to
// come back (the game will refuse their connection for this long, after
// that Qcheck() will ban() them again) and not being too long for the good
// guy who may get banned accidentally.  Qunban() cannot undo the effects
// of ban(), so good guys with a static IP have to wait this long (or until
// a server reset) before they can get back in.
$Qmin = 10;

function Q_msg(%adm,%msg) {
	%msg = "QBan: "@%msg;
	if (%adm) say(%adm,0,"<f1>"@%msg);
	echo(%msg);
}

function Q_log(%adm,%msg) {
	Q_msg(%adm,%msg);
	missionLog(%msg);
}

function Q_save(%adm) {
	$Qtitle = "QBan Ban List";
	%out = "$Qn=0;";
	for (%i=0;%i<$Qn;%i++) {
		%out = %out@"\n$Qnm[$Qn]=\""@$Qnm[%i]@"\";";
		%out = %out@" $Qip[$Qn]=\""@$Qip[%i]@"\";";
		%out = %out@" $Qn++;";
	}
	export("$Qtitle",$Qlistfile,overwrite);
	fileWrite($Qlistfile,append,%out);
	Q_msg(%adm,"Saved list to "@$Qlistfile);
}
function Qsave() { Q_save(0); }

function Qload() {
	if (isFile($Qlistfile) != "") exec($Qlistfile);
}

function Q_auth(%adm,%pw,%cmd) {
	%name = getName(%adm);
	%ip = getConnection(%adm);
	missionLog("remote"@%cmd@" (by "@%name@" "@%ip@")");
	if ($Qpassword == "") %pw = "Go ahead punk, make my day.";
	if (%pw == $Qpassword) return(1);
	%badpw = dataRetrieve(%adm,Qbadpw);
	%badpw++;
	if (%badpw >= $Qmaxbadpw) {
		Q_ban(0,%adm);
	} else {
		dataStore(%adm,Qbadpw,%badpw);
		say(%adm,0,"<f1>QBan: WRONG PASSWORD! Keep it up and you'll be banned.");
	}
	return(0);
}

function Q_info(%adm) {
	Q_msg(%adm,"Version "@$Qver@" by [OF]Pincushion. The list has "@$Qn@" entries.");
}

function Qinfo() { Q_info(0); }

function remoteQinfo(%adm,%pw) {
	if (!Q_auth(%adm,%pw,"Qinfo")) return;
	Q_info(%adm);
}

function Q_banpid(%adm,%pid,%ip) {
	%xip = getConnection(%pid);
	if (%xip == "") {
		Q_msg(%adm,"No player "@%pid);
		return;
	}
	if (%adm == %pid) {
		Q_msg(%adm,"Ban yourself?");
		return;
	}
	%name = getName(%pid);
	$Qip[$Qn] = %ip;
	$Qnm[$Qn] = %name;
	$Qn++;
	Q_log(%adm,"Banned "@%name@" ("@%pid@") "@%ip);
	ban(%pid,$Qmin,$Qreason);
	Q_save(%adm);
}

function Q_ban(%adm,%pid) {
	%ip = getConnection(%pid);
	// strip the port and replace with :0 (a wildcard)
	%i = Qstrrchr(%ip,":");
	%ip = strAlign(%i-1,l,%ip);
	%ip = %ip@":0";
	Q_banpid(%adm,%pid,%ip);
}

function Qban(%pid) { Q_ban(0,%pid); }

function remoteQban(%adm,%pw,%pid) {
	if (!Q_auth(%adm,%pw,"Qban")) return;
	Q_ban(%adm,%pid);
}

function Q_bansubnet(%adm,%pid) {
	%ip = getConnection(%pid);
	// strip the subnet and port and replace with .0:0 (a wildcard)
	%i = Qstrrchr(%ip,".");
	%ip = strAlign(%i-1,l,%ip);
	%ip = %ip@".0:0";
	Q_banpid(%adm,%pid,%ip);
}

function Qbansubnet(%pid) { Q_bansubnet(0,%pid); }

function remoteQbansubnet(%adm,%pw,%pid) {
	if (!Q_auth(%adm,%pw,"Qbansubnet")) return;
	Q_bansubnet(%adm,%pid);
}

function Q_banname(%adm,%name) {
	%npid = playerManager::getPlayerCount();
	for (%i=0;%i<%npid;%i++) {
		%pid = playerManager::getPlayerNum(%i);
		%nm = getName(%pid);
		if (%name == getName(%pid)) {
			Q_ban(%adm,%pid);
			return;
		}
	}
	%msg = "Couldn't find player \""@%name@"\"."@
	    "\nUse playerlist(); to get a player ID, then use Qban.";
	Q_msg(%adm,%msg);
}

function Qbanname(%name) { Q_banname(0,%name); }

function remoteQbanname(%adm,%pw,%name) {
	if (!Q_auth(%adm,%pw,"Qbanname")) return;
	Q_banname(%admid,%name);
}

function Q_banlist(%adm) {
	%msg = $Qn@" Players on the Ban List";
	if ($Qn == 0) {
		Q_msg(%adm,%msg);
		return;
	}
	%msg = %msg@"\nN  Name            IP Address";
	for (%i=0;%i<$Qn;%i++) {
		%nu = stralign(3,l,%i);
		%nm = stralign(16,l,$Qnm[%i]);
		%ip = stralign(20,l,$Qip[%i]);
		%msg = %msg@"\n"@%nu@%nm@%ip;
	}
	Q_msg(%adm,%msg);
}

function Qbanlist() { Q_banlist(0); }

function remoteQbanlist(%adm,%pw) {
	if (!Q_auth(%adm,%pw,"Qbanlist")) return;
	Q_banlist(%adm);
}

function Q_unban(%adm,%N) {
	if ((%N<0) || (%N>=$Qn) || ($Qip[%N] == "")) {
		%msg = "There is no banned player "@%N@"."@
			"\nUse Qbanlist to get a valid N, then try Qunban again.";
		Q_msg(%adm,%msg);
		return;
	}
	Q_msg(%adm,"Unbanning "@$Qnm[%N]@" "@$Qip[%N]);
	$Qn = $Qn - 1;
	if (%N < $Qn) {
		$Qnm[%N] = $Qnm[$Qn];
		$Qip[%N] = $Qip[$Qn];
	}
	Q_save(%adm);
}

function Qunban(%N) { Q_unban(0,%N); }

function remoteQunban(%adm,%pw,%N) {
	if (!Q_auth(%adm,%pw,"Qunban")) return;
	Q_unban(%adm,%N);
}

function remoteBan(%adm,%pw,%pid,%min,%reason) {
	if (!Q_auth(%adm,%pw,"Ban")) return;
	if (%min <= 0) %min = $Qmin;
	if (%reason == "") %reason = "Come back soon.";
	ban(%pid,%min,%reason);
}

// A big thanks to Dull for strAlignR (note the char set used here is limited)
function QstrAlignR(%n,%str) {
	%len = strLen(%str);
	for(%a=1;%a<=%len;%a++) {
		%tmp = strAlign(%a,l,%str);
		%letter[%a] = QletterCheck(%tmp);
	}
	%final = %len - %n + 1;
	%end = "";
	for(%a=%len; %a>=%final; %a--)
		%end = strCat(%letter[%a], %end);
	return(%end);
}
$Qln = 0;
$Ql[$Qln] = "<"; $Qln++;
$Ql[$Qln] = "R"; $Qln++;
$Ql[$Qln] = "r"; $Qln++;
$Ql[$Qln] = "Y"; $Qln++;
$Ql[$Qln] = "y"; $Qln++;
$Ql[$Qln] = "0"; $Qln++;
$Ql[$Qln] = "1"; $Qln++;
$Ql[$Qln] = "2"; $Qln++;
$Ql[$Qln] = "3"; $Qln++;
$Ql[$Qln] = "4"; $Qln++;
$Ql[$Qln] = "5"; $Qln++;
$Ql[$Qln] = "6"; $Qln++;
$Ql[$Qln] = "7"; $Qln++;
$Ql[$Qln] = "8"; $Qln++;
$Ql[$Qln] = "9"; $Qln++;
$Ql[$Qln] = ":"; $Qln++;
$Ql[$Qln] = "."; $Qln++;
function QletterCheck(%str) {
	%len = strLen(%str) - 1;
	%last = strAlign(%len,l,%str);
	for(%a=0;%a<$Qln;%a++) if(%str == strcat(%last,$Ql[%a])) return($Ql[%a]);
	return(" ");
}

// Return 1 if %substr is contained within %str.
function Qstrstr(%str,%substr) {
	%sublen = strlen(%substr);
	%len = strlen(%str) - %sublen + 1;
	for (%i=0;%i<%len;%i++) {
		%s = QstrAlignR(%sublen,stralign(%sublen+%i,l,%str));
		if (%s@" " == %substr@" ") return(1);
	}
	return(0);
}

// Return the index of the rightmost character %chr in string %str
function Qstrrchr(%str,%chr) {
	%len = strlen(%str);
	for (%i=%len;%i>0;%i=%i-1) {
		%str = strAlign(%i,l,%str);
		if (QstrAlignR(1,%str)@" " == %chr@" ") return(%i);
	}
	return(%len);
}

// Any of the following strings found in a name is cause for auto-ban.
$Qbadn = 0;
$Qbad[$Qbadn] = "<R"; $Qbadn++;
$Qbad[$Qbadn] = "<r"; $Qbadn++;
$Qbad[$Qbadn] = "<Y"; $Qbadn++;
$Qbad[$Qbadn] = "<y"; $Qbadn++;
// If you add more strings be sure to add any new characters to $Ql[] above...

function Qcheck(%pid) {
	%name = getName(%pid);
	%ip = getConnection(%pid);
	//Q_msg(0,"Checking "@%name@" ("@%pid@") "@%ip);
	for (%i=0;%i<$Qn;%i++) {
		if (isEqualIP(%ip,$Qip[%i])) {
			// player is in the ban list, ban him
			Q_log(0,"Rejected "@%name@" ("@%pid@") "@%ip);
			ban(%pid,$Qmin,$Qreason);
			return(0);
		}
	}
	for (%i=0;%i<$Qbadn;%i++)
		if (Qstrstr(%name,$Qbad[%i])) {
			// player has a nasty name, ban him and add to the list
			Q_ban(0,%pid);
			return(0);
		}
	if ( strAlign(1,l,%name) == "/" ) {
		say(0,0,%name@" joined the game.");
		//Q_ban(0,%pid);
	}
	Q_msg(0,%name@" is OK.");
	return(1);
}

function Qautocheck(%sec) {
	echo("Qautocheck "@%sec);
	if ($server::MissionFileName == "") return; // no mission yet
	%npid = playerManager::getPlayerCount();
	for (%i=0;%i<%npid;%i++) {
		if (dataRetrieve(%pid,Q) == "") {
			%pid = playerManager::getPlayerNum(%i);
			Qcheck(%pid);
			dataStore(%pid,Q,1);
		}
	}
	schedule("Qautocheck("@%sec@");",%sec);
}

Qload();
Qinfo();
